#ifndef _CODE_H
#define _CODE_H

#include <string.h>
#include <math.h>
#include <alloc.h>
#include <assert.h>

char **table;

char Vig2Encode(char, char);
void VigCrTab(void);
char Vig2Decode(char, char);

long RsaEncode(long b, long n, long e)
{
	long result = 1;
	for(long i=0; i<e; i++)
	{
		result = (result*b) % n;
	}
	return result;
}

long RsaDecode(long b, long n, long d)
{
	long result = 1;
	for(long i=0; i<d; i++)
	{
		result = (result*b) % n;
	}
	return result;
}

char* VigEncode(const char* strin, const char* code)
{
	char *temp, *code2 = "";
	temp = (char*)malloc(sizeof(char)*30);
	assert(temp != NULL);
	code2 = (char*)malloc(sizeof(char)*200);
	assert(code2 != NULL);
	for(int i=0; i<strlen(strin)/strlen(code); i++)
	{
		strcat(code2,code);
	}
	for(i = strlen(code2); i<strlen(strin)%strlen(code); i++)
	{
		code2[i] = code[i-strlen(code2)];
	}
	VigCrTab();
	for(i=0; i<strlen(strin); i++)
	{
		temp[i] = Vig2Encode(strin[i], code2[i]);
	}
	return temp;
}

char Vig2Encode(char strin, char code)
{
	return table[int(strin)-97][int(code)-97];
}

void VigCrTab(void)
{
	table = (char**)malloc(sizeof(char)*26*sizeof(char)*26);
	assert(table != NULL);
	static int index = 0;
	if(index)
		return;
	char *temp;
	int con;
	temp = (char*)malloc(sizeof(char)*26);
	assert(temp != NULL);
	temp = "qwertyuiopasdfghjklzxcvbnm";
	for(int i = 0; i < 26; i++)
	{
		for(int j=0; j<26; j++)
		{
			con = i-j;
			con = abs(con);
			table[i][j] = temp[con];
		}
	}
	index = 1;
}

char* VigDecode(const char* strin, const char* code)
{
	char *temp, *code2;
	temp = (char*)malloc(sizeof(char)*500);
	code2 = (char*)malloc(sizeof(char)*500);
	for(int i=0; i<strlen(strin)/strlen(code); i++)
	{
		strcat(code2,code);
	}
	for(i = strlen(code2); i<strlen(strin)%strlen(code); i++)
	{
		code2[i] = code[i-strlen(code2)];
	}
	VigCrTab();
	for(i=0; i<strlen(strin); i++)
	{
		temp[i] = Vig2Decode(strin[i], code2[i]);
	}
	return temp;
}

char Vig2Decode(char strin, char code)
{
	for(int i=0; i<26; i++)
	{
		if(table[(int)code-97][i] == strin)
		{
			return char(i+97);
		}
	}
	return char(97);
}
#endif